#!/usr/bin/env node
'use strict';

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _winston = require('winston');

var _winston2 = _interopRequireDefault(_winston);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _nodeUserDefaults = require('node-user-defaults');

var _nodeUserDefaults2 = _interopRequireDefault(_nodeUserDefaults);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_nodeUserDefaults2.default.setLocation('~/.node-music-downloader');

_winston2.default.remove(_winston2.default.transports.Console);
_winston2.default.add(_winston2.default.transports.Console, { showLevel: false });

var pkg = _path2.default.resolve(__dirname, '../package.json');
var conf = JSON.parse(_fs2.default.readFileSync(pkg, 'utf8'));

_commander2.default.version(conf.version).usage('<options> query').option('-o, --output [output]', 'Output directory').option('-t, --token [token]', 'Youtube authentication token').option('-r, --results [results]', 'Max results to check', parseInt).option('-s, --save-token', 'Store the Youtube authentication token for future use').parse(process.argv);

var token = _commander2.default.token || _nodeUserDefaults2.default.read('token');
if (_commander2.default.saveToken) {
  _nodeUserDefaults2.default.write('token', token);
}
if (!token) {
  _winston2.default.error(_chalk2.default.red.bold('No token provided!'));
  process.exit();
}

if (_commander2.default.args.length < 1) {
  _winston2.default.error(_chalk2.default.red.bold('No query provided!'));
  process.exit();
}

(0, _index2.default)({
  results: _commander2.default.results || 25,
  query: _commander2.default.args.join(' '),
  directory: _commander2.default.output || process.cwd(),
  verbose: true,
  token: token });